From 7f966d19fd351e99450aea1c050bda358ef626ce Mon Sep 17 00:00:00 2001
From: Jiri Gaisler <jiri@gaisler.se>
Date: Thu, 23 Mar 2017 10:23:46 +0100
Subject: [PATCH 09/11] sim/erc32: Add run options to standalone simulator

	The standalone simulator is extend to allow automatic loading and
	running of binaries at start-up. The simulated time can optionally be
	limited to abort a run-away program.

	* sis.c (main): Add -r option to sis to automatically run applications
	 at start-up. Add -tlim option to limit simulated time, e.g. -tlim 200 s.
---
 sim/erc32/func.c | 18 +++++++++---------
 sim/erc32/sis.c  | 35 ++++++++++++++++++++++++++++-------
 2 files changed, 37 insertions(+), 16 deletions(-)

diff --git a/sim/erc32/func.c b/sim/erc32/func.c
index d4fe8ea..a94a0ca 100644
--- a/sim/erc32/func.c
+++ b/sim/erc32/func.c
@@ -75,7 +75,7 @@ uint32		errmec = 0;
 static int	batch (struct pstate *sregs, char *fname);
 static void	set_rega (struct pstate *sregs, char *reg, uint32 rval);
 static void	disp_reg (struct pstate *sregs, char *reg);
-static uint32	limcalc (float32 freq);
+static uint64	limcalc (float32 freq);
 static void	int_handler (int32 sig);
 static void	init_event (void);
 static int	disp_fpu (struct pstate  *sregs);
@@ -350,11 +350,11 @@ errinjstart()
 
 #endif
 
-static uint32
+static uint64
 limcalc (freq)
     float32		freq;
 {
-    uint32          unit, lim;
+    uint64          unit, lim;
     double	    flim;
     char           *cmd1, *cmd2;
 
@@ -363,14 +363,14 @@ limcalc (freq)
     if ((cmd1 = strtok(NULL, " \t\n\r")) != NULL) {
         lim = VAL(cmd1);
         if ((cmd2 = strtok(NULL, " \t\n\r")) != NULL) {
-            if (strcmp(cmd2,"us")==0) unit = 1;
-      	    if (strcmp(cmd2,"ms")==0) unit = 1000;
-            if (strcmp(cmd2,"s")==0)  unit = 1000000;
+	    if (strcmp(cmd2,"us")==0) unit = 1;
+	    if (strcmp(cmd2,"ms")==0) unit = 1000;
+	    if (strcmp(cmd2,"s")==0)  unit = 1000000;
         }
-        flim = (double) lim * (double) unit * (double) freq + 
+        flim = (double) lim * (double) unit * (double) freq +
 	   (double) ebase.simtime;
-        if ((flim > ebase.simtime) && (flim < 4294967296.0)) {
-            lim = (uint32) flim;
+        if (flim > ebase.simtime) {
+            lim = (uint64) flim;
         } else  {
             printf("error in expression\n");
             lim = -1;
diff --git a/sim/erc32/sis.c b/sim/erc32/sis.c
index 689d17e..83dd5cf 100644
--- a/sim/erc32/sis.c
+++ b/sim/erc32/sis.c
@@ -145,6 +145,8 @@ main(argc, argv)
     int             cmdi = 0;
     int             i;
     int             lfile = 0;
+    char	    tlim[64] = "";
+    int		    run = 0;
 
     cfile = 0;
     for (i = 0; i < 64; i++)
@@ -189,6 +191,8 @@ main(argc, argv)
 		dumbio = 1;
 	    } else if (strcmp(argv[stat], "-nouartrx") == 0) {
 		nouartrx = 1;
+	    } else if (strcmp(argv[stat], "-r") == 0) {
+		run = 1;
 	    } else if (strcmp (argv[stat], "-leon2") == 0) {
 		ms = &leon2;
 		if (freq == 14) freq = 50;
@@ -197,6 +201,13 @@ main(argc, argv)
 		ms = &leon3;
 		if (freq == 14) freq = 50;
 		cputype = CPU_LEON3;
+	    } else if (strcmp(argv[stat], "-tlim") == 0) {
+		if ((stat + 2) < argc) {
+		    strcpy(tlim, "tlim ");
+		    strcat(tlim, argv[++stat]);
+		    strcat(tlim, " ");
+		    strcat(tlim, argv[++stat]);
+		}
 	    } else {
 		printf("unknown option %s\n", argv[stat]);
 		usage();
@@ -250,6 +261,10 @@ main(argc, argv)
 	strcat(bacmd, cfile);
 	exec_cmd(&sregs, bacmd);
     }
+    if (tlim[0]) {
+	exec_cmd(&sregs, tlim);
+    }
+
     while (cont) {
 
 	if (cmdq[cmdi] != 0) {
@@ -261,14 +276,20 @@ main(argc, argv)
 	    free(cmdq[cmdi]);
 	    cmdq[cmdi] = 0;
 	}
-	cmdq[cmdi] = readline("sis> ");
-	if (cmdq[cmdi] && *cmdq[cmdi])
-	    add_history(cmdq[cmdi]);
-	if (cmdq[cmdi])
-	    stat = exec_cmd(&sregs, cmdq[cmdi]);
+	if (run) {
+	    stat = exec_cmd(&sregs, "run");
+	    cont = 0;
+	}
 	else {
-	    puts("\n");
-	    exit(0);
+	    cmdq[cmdi] = readline("sis> ");
+	    if (cmdq[cmdi] && *cmdq[cmdi])
+		add_history(cmdq[cmdi]);
+	    if (cmdq[cmdi])
+		stat = exec_cmd(&sregs, cmdq[cmdi]);
+	    else {
+		puts("\n");
+		exit(0);
+	    }
 	}
 	switch (stat) {
 	case OK:
-- 
2.7.4

